backend/GoodChat/urls.py
from django.contrib import admin
from django.urls import path
from main import views as main_views
from main import api as main_api
from users import views as users_views
from users import api as users_api
from chat import views as chat_views
from chat import api as chat_api 
from django.conf.urls.static import static
from django.conf import settings
from rest_framework_simplejwt.views import TokenObtainPairView
from rest_framework_simplejwt.views import TokenRefreshView
from rest_framework_simplejwt.views import TokenVerifyView

urlpatterns = [
    path('api/token', TokenObtainPairView.as_view(), name='token_obtain_pair'),
    path('api/token/refresh', TokenRefreshView.as_view(), name='token_refresh'),
    path('api/token/verify', TokenVerifyView.as_view(), name='token_verify'),
    
    path('api/register', users_api.Register.as_view()),
    path('api/profile/self', users_api.SelfProfile.as_view()),
    path('api/profile/<int:id>', users_api.GetProfile.as_view()),
    path('api/profile/edit', users_api.EditProfile.as_view()),
    path('api/users/find', users_api.FindUser.as_view()),
    
    path('api/post/<int:id>', main_api.GetPost.as_view()),
    path('api/post/<int:id>/bookmark', main_api.AddDeleteBookmark.as_view()),
    path('api/post/<int:id>/delete', main_api.DeletePost.as_view()),
    path('api/post/<int:id>/edit', main_api.EditPost.as_view()),
    path('api/post/<int:id>/comments', main_api.GetComments.as_view()),
    path('api/post/getUserPosts/<int:id>', main_api.GetUserPosts.as_view()),
    path('api/post/getFeed', main_api.GetFeed.as_view()),
    path('api/post/new', main_api.AddPost.as_view()),
    path('api/comment/send', main_api.SendComment.as_view()),
    path('api/bookmarks', main_api.GetBookmarks.as_view()),
    
    path('api/chat/create', chat_api.CreateChat.as_view()),
    path('api/chat/<int:id>', chat_api.GetChat.as_view()),
    path('api/chat/<int:id>/access', chat_api.GetChatAccessMode.as_view()),
    path('api/chat/<int:id>/info', chat_api.GetChatInfo.as_view()),
    path('api/chat/<int:id>/edit', chat_api.EditChat.as_view()),
    path('api/chat/<int:id>/leave', chat_api.LeaveChat.as_view()),
    path('api/chatlist', chat_api.GetChatlist.as_view()),
    path('api/chat/sendMessage', chat_api.SendMessage.as_view()),
    path('api/dialog/get/<int:id>', chat_api.GetDialog.as_view()),
    
    path('api/friendlist/<int:id>', users_api.GetFriendList.as_view()),
    path('api/friend/request/list', users_api.GetFriendRequestList.as_view()),
    path('api/friendship/refuse', users_api.RefuseFriendship.as_view()),
    path('api/friendship/status/<int:friend_id>', users_api.GetFriendshipStatus.as_view()),
    
    path('api/friend/request/send/<int:friend_id>', users_api.SendFriendRequest.as_view()),
    path('api/friend/request/withdraw/<int:friend_id>', users_api.WithdrawFriendRequest.as_view()),
    path('api/friend/request/accept/<int:friend_id>', users_api.AcceptFriendRequest.as_view()),
    path('api/friend/request/decline/<int:friend_id>', users_api.DeclineFriendRequest.as_view()),
    
    path('admin/', admin.site.urls),
    path('', main_views.main_page, name='home'),
    path('bookmarks', main_views.bookmarks_page, name='bookmarks'),
    path('add-bookmark/<int:post_id>', main_views.add_or_delete_bookmark, name='add-delete-bookmark'),
    path('settings/', main_views.settings_page, name='setting'),
    path('edit/', users_views.settings_profile, name = 'edit'),
    path('login/', users_views.login_page, name='login'),
    path('register/', users_views.registration_page, name='registration'),
    path('logout/', users_views.logout_page, name='logout'),
    path('profile/<int:id>', main_views.profile, name = 'profile'),
    path('profile', main_views.self_profile, name='self-profile'),
    path('post/<int:id>', main_views.post, name='post'),
    path('postedit/<int:id>', main_views.edit_post, name='postedit'),
    path('addpost', main_views.add_post_page, name = 'addpost'),
    path('findfriend', main_views.find_friend_page, name = 'findfriend'),
    path('messenger', main_views.messenger_page, name='messenger'),
    path('chatlist', chat_views.chat_list, name='chat-list'),
    path('chat/<int:id>', chat_views.chat_page, name='chat'),
    path('dialog/<int:interlocutor_id>', chat_views.open_dialog, name='open-dialog'),
    path('friendlist/<int:id>', users_views.friend_list, name='friend-list'),
    path('addfriend/<int:recipient_id>', users_views.invite_friend, name='add-friend'),
    path('reject_request/<int:recipient_id>', users_views.reject_request_friend, name='reject_request_friend'),
    path('chat/info/<int:chat_id>', chat_views.multichat_info, name='multychat-info'),   
    path('chat/settings/<int:chat_id>', chat_views.multichat_settings, name='multychat-settings'),   
    path('chat/leave/<int:chat_id>', chat_views.leave_chat, name='leave-chat'),   
    path('chat/new/multy', chat_views.new_multychat, name='new-multychat'),
    path('postdelete/<int:id>', main_views.post_delete, name = 'postdelete')
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

backend/main/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.contrib.auth.models import User
from django.core.exceptions import ValidationError


class RegistrForm(UserCreationForm):
    username = forms.CharField(label='Логин', widget=forms.TextInput(attrs={
        'class': 'form-input',
        'placeholder': 'Log In'
    }))
    password1 = forms.CharField(label='Пароль', widget=forms.PasswordInput(attrs={
        'class': 'form-input',
        'placeholder': 'Password'
    }))
    password2 = forms.CharField(label='Повтор пароля', widget=forms.PasswordInput(attrs={
        'class': 'form-input',
        'placeholder': 'Reenter Password'
    }))
    email = forms.EmailField(max_length=254, widget=forms.EmailInput(attrs={
        'class': 'form-input',
        'placeholder': 'E-mail'
    }))
    nickname = forms.CharField(label='Повтор пароля', widget=forms.PasswordInput(attrs={
        'class': 'form-input',
        'placeholder': 'Nickname'
    }))

    class Meta:
        model = User
        fields = ('nickname', 'username', 'email', 'password1', 'password2')

    def clean_password2(self):
        password1 = self.cleaned_data['password1']
        password2 = self.cleaned_data['password2']

        if password1 and password2 and password1 != password2:
            raise ValidationError("Passwords are not same!")
        return password2


class LogForm(forms.Form):
    username = forms.CharField(widget=forms.TextInput(attrs={
        'class': 'form-input',
        'placeholder': 'Login'
    }))
    password = forms.CharField(widget=forms.PasswordInput(attrs={
        'class': 'form-input',
        'placeholder': 'Password'
    }))


class PostForm(forms.Form):
    content = forms.CharField(widget=forms.Textarea(attrs={
        'class': 'text-of-new-post',
        'placeholder': 'Your text'
    }))
    photo = forms.ImageField(widget=forms.ClearableFileInput(), required=False)

class EditPostForm(forms.Form):
    is_del = forms.CharField(widget=forms.TextInput(attrs={
        'id': 'is_del',
        'value': '0',
        'style': 'display: none;'
    }), required=False)
    content = forms.CharField(widget=forms.Textarea(attrs={
        'class': 'text-of-new-post',
        'placeholder': 'Your text'
    }))
    photo = forms.ImageField(widget=forms.ClearableFileInput(), required=False)


class CommentForm(forms.Form):
    content = forms.CharField(widget=forms.Textarea(attrs={
        'class': 'message_area',
        'placeholder': 'New comment'
    }))


class FrindSearchRequestForm(forms.Form):
    querry = forms.CharField(widget=forms.TextInput(attrs={
        'class': 'search-id-input',
        'placeholder': 'Search(ID/Name)'
    }))

backend/users/views.py
from django.shortcuts import render
from django.shortcuts import redirect
from django.shortcuts import get_object_or_404
from django.contrib.auth import login
from django.contrib.auth import authenticate
from django.contrib.auth import logout
from django.contrib.auth.decorators import login_required
from django.db import IntegrityError
from django.urls import reverse
from .forms import LoginForm
from .forms import RegistrationForm
from .forms import ProfileEditForm
from .models import User
from .models import Friend
from .models import Profile
from .models import FriendRequest
from .utils import get_profile
from .utils import get_friends
from .utils import convert_profile_to_dict
from .utils import friend_able_to_invite
from .utils import accept_friend_request
from .utils import are_friends
from .utils import refuse_friendship
from .utils import friend_invited
from .utils import deny_friend_request
from .signals import user_created
from users.utils import get_friend_add_button_state
    
def registration_page(request):
    """
    View function which processes the user registration form 
    and performs the registration of new user.
    """
    if request.user.is_authenticated:
        return redirect('self-profile')

    context = {}

    if request.method == 'POST':
        form = RegistrationForm(request.POST)
        if form.is_valid():
            context['form'] = form

            u_name = form.data['name']
            u_surname = form.data['surname']
            u_login = form.data['login']
            u_email = form.data['email']
            u_password = form.data['password']

            try:
                user = User.objects.create_user(username=u_login,
                                                email=u_email,
                                                password=u_password,
                                                is_active=True)

                user.save()

                user_created.send(sender=User,
                                  user=user,
                                  name=u_name,
                                  surname=u_surname)

                user = authenticate(request, username=u_login, password=u_password)
                login(request, user)
                
                return redirect('self-profile')
            except IntegrityError as error:
                context['form'] = form
                is_login_unique = False
                is_email_unique = False

                try:
                    User.objects.get(username=u_login)
                except User.DoesNotExist:
                    is_login_unique = True

                try:
                    User.objects.get(email=u_email)
                except User.DoesNotExist:
                    is_email_unique = True

                if not is_login_unique and not is_email_unique:
                    not_unique_fields = 'login, email'
                elif not is_login_unique:
                    not_unique_fields = 'login'
                elif not is_email_unique:
                    not_unique_fields = 'email'

                message = f"""
                Пользователь с таким именем уже существует
                Посмотрите это поле: {not_unique_fields}.
                """

                context['message'] = message

                print(error)

        else:
            context['form'] = form

    else:
        context['form'] = RegistrationForm()

    return render(request, 'registration.html', context=context)


def login_page(request):
    """
    View function which processes the user authorization form 
    and performs the authorization.
    """
    if request.user.is_authenticated:
        return redirect('self-profile')

    context = {}

    if request.method == 'POST':
        auth_form = LoginForm(request.POST)

        if auth_form.is_valid():
            username = auth_form.data['username']
            password = auth_form.data['password']
            user = authenticate(request, username=username, password=password)

            if user is not None:
                login(request, user)
                return redirect('self-profile')

            context['message'] = """
            Неправильный логин или пароль
            """
            context['form'] = auth_form

        else:
            context['form'] = LoginForm()

    else:
        context['form'] = LoginForm()

    return render(request, 'login.html', context=context)

@login_required
def settings_profile(request):
    context = {}

    if request.method == 'POST':
        form = ProfileEditForm(request.POST)
        if form.is_valid():
            context['form'] = form
            profile = get_profile(request.user)
            profile.name = form.cleaned_data['name']
            profile.surname = form.cleaned_data['surname']
            profile.about = form.cleaned_data['about']
            profile.country = form.cleaned_data['country']
            profile.city = form.cleaned_data['city']
            profile.education = form.cleaned_data['education']
            profile.company = form.cleaned_data['company']
            profile.hobby = form.cleaned_data['hobby']
            print(dict(request.FILES))
            if 'avatar-profile-form' in dict(request.FILES):
                photo = dict(request.FILES)['avatar-profile-form']
                profile.avatar = photo[0]
            elif dict(request.POST)['is_del'][0] == "1":
                profile.avatar = "images/DEFAULT_AVATAR.png"
            profile.save()
            return redirect('self-profile')
        else:
            context['form'] = form

    else:
        profile = get_profile(request.user)
        form_init = {'name': profile.name,
                     'surname': profile.surname,
                     'about': profile.about,
                     'country': profile.country,
                     'city': profile.city,
                     'education': profile.education,
                     'company': profile.company,
                     'hobby': profile.hobby}
        context['form'] = ProfileEditForm(initial=form_init)
        context['avatar_name'] = profile.avatar.name.split('/')[-1]
        context['avatar_url'] = profile.avatar.url
        context['avatar_value'] = profile.avatar
    return render(request, 'settings_profile.html', context=context)

@login_required
def friend_list(request, id):
    try:    
        current_user = User.objects.get(id=id)
    except User.DoesNotExist:
        return redirect('home')
    profile = Profile.objects.get(id=id)
    context = {'profile': {'id': profile.id,
                           'name': profile.name
                           }
               }
    
    friends = get_friends(current_user)
    friends = [convert_profile_to_dict(get_profile(friend))
               for friend in friends]
    if current_user == request.user:
        friend_requests = FriendRequest.objects.filter(recipient=request.user)
        inviters = [get_profile(friend_request.inviter)
                    for friend_request in friend_requests]
        context['friend_inviters'] = [convert_profile_to_dict(inviter)
                                      for inviter in inviters]
        context['add_friend_button'] = get_friend_add_button_state(request.user.id, id)
    context['friends'] = friends
    return render(request, 'friendlist.html', context)




@login_required
def invite_friend(request, recipient_id):
    try:
        recipient = User.objects.get(id=recipient_id)
    except User.DoesNotExist:
        print('UNKNOWN PERSON')
        return redirect('self-profile')
    
    inviter = request.user
    
    if friend_able_to_invite(inviter, recipient):
        invitation = FriendRequest(inviter=inviter, recipient=recipient)
        invitation.save()
        print('REQUEST SENDED')
        return redirect(reverse('friend-list', args=[request.user.id]))
    elif are_friends(inviter, recipient):
        refuse_friendship(inviter, recipient)
        return redirect(reverse('friend-list', args=[request.user.id]))
    elif friend_invited(inviter, recipient):
        deny_friend_request(inviter, recipient)
        return redirect(reverse('friend-list', args=[request.user.id]))
    else:
        try:
            accept_friend_request(recipient, inviter)
        except ValueError:
            print('REQUEST DENIED')
            return redirect(reverse('friend-list', args=[request.user.id]))
        else:
            return redirect(reverse('friend-list', args=[request.user.id]))


@login_required
def reject_request_friend(request, recipient_id):
    try:
        recipient = User.objects.get(id=recipient_id)
    except User.DoesNotExist:
        print('UNKNOWN PERSON')
        return redirect('self-profile')

    inviter = request.user

    if friend_able_to_invite(inviter, recipient):
        invitation = FriendRequest(inviter=inviter, recipient=recipient)
        invitation.save()
        print('REQUEST SENDED')
        return redirect(reverse('friend-list', args=[request.user.id]))
    elif are_friends(inviter, recipient):
        refuse_friendship(inviter, recipient)
        return redirect(reverse('friend-list', args=[request.user.id]))
    elif friend_invited(inviter, recipient):
        deny_friend_request(inviter, recipient)
        return redirect(reverse('friend-list', args=[request.user.id]))
    else:
        try:
            deny_friend_request(recipient, inviter)
        except ValueError:
            print('REQUEST DENIED')
            return redirect(reverse('friend-list', args=[request.user.id]))
        else:
            return redirect(reverse('friend-list', args=[request.user.id]))

@login_required
def logout_page(request):
    logout(request)
    return redirect('home')

backend/users/templates/friendlist.html
{% extends 'base.html' %}
{% load static %}

{% block style %}
<link rel="stylesheet" href="{% static '/css/friendlist.css' %}">
{% endblock %}
{% block title %}Friends{% endblock %}

{% block content %}
{% if friends or friend_inviters %}
<div class="friend_box">
    <div class="title_h">
        {% if profile.id == self_profile.id %}
        <h2 class="requests_h1" id="title">Friends List</h2>
        <button class="btn_request_h2" id="btn">Friend Request</button>
        {% else %}
        <h2 class="requests_h1" id="title">{{profile.name}} Friends List</h2>
        {% endif %}
    </div>
    <div class="message_none" {% if friends %} style="display:none;" {% else %} style="display:flex;" {% endif %}>No
        friends yet</div>
    {% for friend in friends %}

    <div class="friendlist_item" id="friend_item">
        <img src="{{ friend.avatar.url }}" class="friend-avatar image_avatar">
        <a class="friend_name" href="{% url 'profile' friend.id %}">{{ friend.full_name }}</a>
        {% if profile.id == self_profile.id %}
        <a class="button_write accept" href="{% url 'add-friend' friend.id %}">Delete</a>
        <a class="button_write reject" href="{% url 'open-dialog' friend.id %}">Message</a>
        {% endif %}
    </div>

    {% endfor %}
    {% for inviter in friend_inviters %}
    <div class="friendrequest_item" id="request_item">
        {% if profile.id == self_profile.id %}
        <img src="{{ inviter.avatar.url }}" class="friend-avatar image_avatar">
        <a class="friend_name" href="{% url 'profile' inviter.id %}">{{ inviter.full_name }}</a>
        <a class="button_write accept" href="{% url 'add-friend' inviter.id%}">Accept</a>
        <a class="button_write reject" href="{% url 'reject_request_friend' inviter.id%}">Deny</a>
        {% endif %}
    </div>
    {% endfor %}

</div>
{% elif profile.id != self_profile.id %}
<div class="zero_bookmarks">
    <p class="alarm_posts">This user has yet no friends :c </p>
</div>
{% else %}
<div class="zero_bookmarks">
    <p class="alarm_posts">Yo do not yet have friends :c </p>
    <a class="btn_add" href="{% url 'home' %}">Go back</a>
</div>
{% endif %}
{% endblock %}
{% block js %}
<script src="{% static '/js/friendlist.js' %}"></script>
{% endblock %}

backend/users/templates/login.html
{% extends 'base.html' %}
{% load static %}

{% block style %}<link rel="stylesheet" href="{% static '/css/reg-log.css' %}">{% endblock %}
{% block title %}Authorization{% endblock %}

{% block content %}

    <div class="reg_box">

        <div class="text_box_rules">
            <h2 class="rules_head">Rules of the programming club</h2>
            <p class="rules">
            <ul>
                <li>First rule of the programming club - Never talk about programming club.</li>
                <li>Second  rule of the programming club - Never EVER talk about programming club.</li>
                <li>Thierd rule of the programming club - If (developer.said() == “COMMIT” or  developer.exhaled() or developer.pushed(commit) == True): Project.Fineshed()</li>
                <li>Forth rule of the programming club - Only two and I half men work on a project.</li>
                <li>Fifth rule of the programming club - Commits should go one after another. Not all at once.</li>
                <li>Sixth rule of the programming club - DO NOT write more than one line of code (time period not included).</li>
                <li>Seventh rule of the programming club - You should programm as far as you need to not less and absolutely not more.</li>
                <li>Eighth rule of the programming club - The one who found a bug in the code no metter his specialization back or front is now obliged to debug the whole code.</li>
            </ul>



            </p>
        </div>

        <div class="input_form">
            <h1 class="reg-header">Authorization</h1><br>
            <!-- <div>Message: "{{ message }}"</div> -->
            <form method="POST" class="form-reg">
                {% csrf_token %}
                {% for field in form %}
                <p>{{ field }}</p>
                <div class="form-error">{{ field.errors }}</div>
                {% endfor %}
                {% if message %}
                <p class="form-error">{{ message }}</p>
                {% endif %}

                <button type="submit" class="btn_add">Log In</button>

            </form>
            <a class="auth-link" href="{% url 'registration' %}">No Account?</a>
        </div>
    </div>


{% endblock %}

backend/users/templates/registration.html
{% extends 'base.html' %}
{% load static %}

{% block style %}<link rel="stylesheet" href="{% static '/css/reg-log.css' %}">{% endblock %}
{% block title %}Registration{% endblock %}

{% block content %}

    <div class="reg_box">

    <div class="text_box_rules">
    <h2 class="rules_head">Rules of the programming club</h2>
    <p class="rules">
    <ul>
                <li>First rule of the programming club - Never talk about programming club.</li>
                <li>Second  rule of the programming club - Never EVER talk about programming club.</li>
                <li>Thierd rule of the programming club - If (developer.said() == “COMMIT” or  developer.exhaled() or developer.pushed(commit) == True): Project.Fineshed()</li>
                <li>Forth rule of the programming club - Only two and I half men work on a project.</li>
                <li>Fifth rule of the programming club - Commits should go one after another. Not all at once.</li>
                <li>Sixth rule of the programming club - DO NOT write more than one line of code (time period not included).</li>
                <li>Seventh rule of the programming club - You should programm as far as you need to not less and absolutely not more.</li>
                <li>Eighth rule of the programming club - The one who found a bug in the code no metter his specialization back or front is now obliged to debug the whole code.</li>
            </ul>



    </p>
    </div>
    <div class="input_form">
        <h1 class="reg-header">Registration</h1><br>
        <form method="post" class="form-reg">



            {% csrf_token %}
            {% for f in form %}
            <p>{{ f }}</p>
            <div class="form-error">{{ f.errors }}</div>
            {% endfor %}
            {% if message %}    
            <div class="form-error"> WARNING {{ message }}</div>
            {% endif %}
            <button type="submit" class="btn_add">Register</button>
            
        </form>
        <a class="auth-link" href="{% url 'login' %}">Already a gogorik?</a>
    </div>
    </div>


{% endblock %}

backend/users/templates/settings_profile.html
{% extends 'base.html' %}
{% load static %}
{% block style %}<link rel="stylesheet" href="{% static '/css/settings_profile.css' %}">{% endblock %}
{% block title %}Profile Settings{% endblock %}

{% block content %}
    <div class="profile_box">
        <div class = "side_menu_settings">
            <h1 class = "settings_tittle">Settings</h1>
            <a href = "#profile_avatar" class = "settings_link">Profile Picture</a>
            <a href = "#profile_name" class = "settings_link">Name</a>
            <a href = "#profile_information" class = "settings_link">About</a>
            <a href = "#profile_data" class = "settings_link">Personal Data</a>

            <div class = "settings_buttons">
                <button class="settings_btn settings_btn1" onclick="location.href = '{% url 'edit' %}'">Cancel</button>
                <button class="settings_btn settings_btn2 settings_save" form="edit_form">Apply</button>
            </div>
        </div>
        <div class = "content_settings">
            <form method="POST" id="edit_form" enctype="multipart/form-data">
                {% csrf_token %}
                <div id = "profile_avatar" class = "settings_settings_devider">
                    <h3 class = "settings_block_tittle">Profile Picture</h3>
                    <div class = "settings_change_menu">
                        <div class="input-file-row" id="box-img">
						    <label class="input-file" id="add_btn" style="visibility: hidden; width: 0px; height: 0px; margin: 0px;">
						    <input type="file" name="avatar-profile-form" accept="image/*" id="id_photo" value="{{chat_avatar_value}}">
						    <span>Select an Image</span>
						    </label>
					        <div id="input-list" class="input-file-list" style="margin: 0px auto;">
                                <div class="input-file-list-item">
                                    <a href="#" onclick="removeFilesItem(this); return false;" class="input-file-list-remove">x</a>
                                    <img class="input-file-list-img" src="{{avatar_url}}">
                                </div>
                            </div>
				        </div>
                        <input id = 'is_del' name="is_del" type="text" style="display: none;" value="0">
                        <div class = "settings_info_box">
                            <p class ="displayed_info">{{ avatar_name }}</p>
                        </div>
                    </div>
                </div>

                <div id = "profile_name" class = "settings_settings_devider">
                    <h3 class = "settings_block_tittle">Profile Name</h3>
                    <div class = "settings_change_menu">
                        <div class = "settings_info_box">
                            <!-- <input placeholder="{{ profile.name }}" id = "name_input" type="text" class = "settings_input" required minlength="2" maxlength="14" size="100">
                            <input placeholder="{{ profile.surname }}" id = "surname_input" type="text" class = "settings_input" required minlength="7" maxlength="14" size="100"> -->
                            {{ form.name }}
                            {{ form.surname }}
                        </div>
                    </div>
                </div>

                <div id = "profile_information" class = "settings_settings_devider">
                    <h3 class = "settings_block_tittle">About</h3>
                    <div class = "settings_change_menu">
                        <div class = "settings_info_box">
                            <!-- <textarea class = "settings_input" rows="5" cols="33">{{ profile.about }}</textarea> -->
                            {{ form.about }}
                        </div>
                    </div>
                </div>

                <div id = "profile_data" class = "settings_settings_devider">
                    <h3 class = "settings_block_tittle">Private Data</h3>
                    <div class = "settings_change_menu">
                        <div class = "settings_info_box">
                            <label for = "id_hobby">I like: </label>
                            <!-- <input id = "settings_hobby" type="text" class = "settings_input" required minlength="2" maxlength="100" size="100" placeholder="{{ profile.hobby }}"></input> -->
                            {{ form.hobby }}
                            <label for = "id_hobby">City/Town: </label>
                            <!-- <input id = "settings_city" type="text" class = "settings_input" required minlength="2" maxlength="20" size="100" placeholder="{{ profile.city }}"></input> -->
                            {{ form.city }}
                            <label for = "id_hobby">Education: </label>
                            <!-- <input id = "settings_edu" type="text" class = "settings_input" required minlength="2" maxlength="40" size="100" placeholder="{{ profile.education }}"></input> -->
                            {{ form.education }}
                            <label for = "id_hobby">Company: </label>
                            <!-- <input id = "settings_company" type="text" class = "settings_input" required minlength="2" maxlength="40" size="100"placeholder="{{ profile.company }}"></input> -->
                            {{ form.company }}
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
{% endblock %}
{% block js %}
<script src="{% static '/js/settings.js' %}"></script>
<script src="https://snipp.ru/cdn/jquery/2.1.1/jquery.min.js"></script>
<script src="{% static '/js/settings_profile.js' %}"></script>
{% endblock %}